﻿var webSvc = cmsGetServiceAddress();
var resFld = "#spanResults";
var hdnFld = "#";
var fldSearch = "#";
var srchMthd = 'FindUsers';
var hasResults = false;

function resetSearchFields() {
	$(hdnFld).val('');
	$(resFld).html('&nbsp;');
}

function initFindUsers(hiddenField, searchBox) {
	hdnFld = '#' + hiddenField;
	fldSearch = '#' + searchBox;
	srchMthd = 'FindUsers';

	bindBehavior();
}

function initFindUsersMethod(hiddenField, searchBox, methodName) {
	hdnFld = '#' + hiddenField;
	fldSearch = '#' + searchBox;
	srchMthd = methodName;

	bindBehavior();
}

function loadResults(data, response) {
	response($.map(data, function (item) {
		return {
			value: item.UserName + " (" + item.Email + ")",
			id: item.UserId
		}
	}));

	if (data.length < 1) {
		$(resFld).attr('style', 'color: #990000;');
		$(resFld).text('  No Results  ');
		hasResults = false;
	} else {
		$(resFld).attr('style', 'color: #009900;');
		if (data.length == 1) {
			$(resFld).text('  ' + data.length + ' Result  ');
		} else {
			$(resFld).text('  ' + data.length + ' Results  ');
		}
		hasResults = true;
	}
}

function bindBehavior() {
	$(fldSearch).on('change keyup paste textchange', function () {
		if ($(fldSearch).val().length < 1) {
			resetSearchFields();
		}
	});

	$(fldSearch).focus(function () {
		if (hasResults && $('#ui-id-1').length > 0) {
			if ($(fldSearch).val().length >= 1) {
				$('#ui-id-1').css('display', '');
			}
		}
	});

	$.ajaxSetup({ cache: false });

	var webMthd = webSvc + "/" + srchMthd;

	$(fldSearch).autocomplete({
		source: function (request, response) {
			hasResults = false;
			resetSearchFields();
			var search = MakeStringSafe(request.term);

			$.ajax({
				url: webMthd + "?searchTerm=" + encodeURIComponent(search),
				type: 'GET',
				dataType: 'json',
				contentType: "application/json; charset=utf-8",
				//data: JSON.stringify({ searchTerm: search }),
				dataFilter: function (data) { return data; },

				success: function (data) {
					loadResults(data, response);
				},

				error: function (xmlRequest, textStatus, errorThrown) {
					resetSearchFields();
					cmsAjaxFailed(xmlRequest);
				}
			});
		},

		select: function (event, ui) {
			resetSearchFields();
			if (ui.item) {
				$(hdnFld).val(ui.item.id);
			}
			$(resFld).html('&nbsp;');
		},
		minLength: 1,
		delay: 1000
	});
}